/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by webpigeon on 02/01/23.
//

#include "hexboard/camera.hpp"

#include "fggl/math/fmath.hpp"

#include <cmath>

namespace demo::hexboard {

	void Camera2D::update(float /*delta*/) {
		m_location = fggl::math::smooth_add( m_location, m_target, m_scale );
		if ( m_trauma > 0 ) {
			m_trauma = std::max( m_trauma - TRAUMA_DECAY, 0.0F );
		}
	}

}