/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by webpigeon on 05/11/22.
//

#include "fggl/audio/openal/module.hpp"

namespace fggl::audio {

	void OpenAL::wireServices(services::ModuleBinder& binder) {
		binder.bind<audio::AudioService>().to<openal::AudioServiceOAL, assets::AssetManager>();
	}

	void OpenAL::setup(services::Generator *generator) {
		Module::setup(generator);

		// register asset loaders
		auto loader = generator->getLazy<assets::Loader>();
		loader->setFactory( ASSET_CLIP_SHORT, openal::load_vorbis, assets::LoadType::PATH );

		auto checkin = generator->getLazy<assets::CheckinAdapted>();
		checkin->setLoader( RES_OGG_VORBIS, openal::load_vorbis_short, openal::check_vorbis);
	}

}