/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by webpigeon on 10/12/22.
//

#include "fggl/grid/hexagon.hpp"

namespace fggl::grid {

	std::vector<IntHex> lineTo(const IntHex& start, const IntHex& end) {
		const int distance = start.distance(end);
		std::vector<IntHex> line;
		for (auto i=0; i < distance; ++i) {
			line.push_back( round2(hexLerp(start, end, 1.0F/distance * i)) );
		}
		return line;
	}

} // namespace fggl:grid
