/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by webpigeon on 22/10/22.
//

#ifndef FGGL_DATA_TEXTURE_HPP
#define FGGL_DATA_TEXTURE_HPP

#include "fggl/assets/module.hpp"
#include "fggl/math/types.hpp"

namespace fggl::data {
	constexpr auto DATA_TEXTURE2D = assets::AssetType::make("gfx::texture");

	struct Texture2D {
		math::vec2i size;
		int channels;
		unsigned char* data;

		Texture2D() = default;
		Texture2D(const Texture2D& other) = delete;

		inline ~Texture2D() {
			std::free(data);
		}
	};

}

#endif //FGGL_DATA_TEXTURE_HPP
