/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by webpigeon on 27/06/22.
//

#ifndef FGGL_DISPLAY_GLFW_MODULE_HPP
#define FGGL_DISPLAY_GLFW_MODULE_HPP

#include "fggl/display/window.hpp"
#include "fggl/input/module.hpp"

#include "fggl/services/module.hpp"
#include "fggl/display/glfw/window.hpp"
#include "fggl/display/glfw/services.hpp"

namespace fggl::display {

	struct GLFW : public services::Module {
		FGGL_MODULE(fggl::display::GLFW, fggl::gfx::API, fggl::input::Generic)

		void setup(services::Generator*) override;
		void teardown() override;

		void wireServices(services::ModuleBinder& binder) override;

		private:
			std::shared_ptr<glfw::GlfwContext> m_context;
	};


} // namespace fggl::display

#endif //FGGL_DISPLAY_GLFW_MODULE_HPP
